export declare type Tree<T> = {
    value: T;
    children?: Tree<T>[];
};
declare type ForEachFunction<T> = (node: T) => void;
export declare function forEach<T = any>(tree: Tree<T>, fn: ForEachFunction<T>): void;
declare type MapFunction<T, U> = (value: T, children?: Tree<T>[]) => U;
export declare function map<T = any, U = any>(tree: Tree<T>, fn: MapFunction<T, U>): Tree<U>;
export declare function flatten<T>(tree: Tree<T>): T[];
export declare function flatMap<T = any, U = any>(tree: Tree<T>, fn: MapFunction<T, U>): U[];
export declare type SortFunction<T> = (a: Tree<T>, b: Tree<T>) => number;
export declare function sort<T = any>(tree: Tree<T>, fn: SortFunction<T>): Tree<T>;
export declare type FilterFunction<T> = (value: T, children?: Tree<T>[]) => boolean;
export declare function filter<T = any>(tree: Tree<T>, fn: FilterFunction<T>): Tree<T> | null;
export {};
